/*
 * stokes.c --- `̈ŒStokes̗Lvf߂
 *
 * written by Shioya
 *
 * RpC
 *    ccmg stokes.c
 *
 * s
 *    ./stokes ̈f[^ ۑt@C
 */

#define ADD

#include <math.h>
#include <stdio.h>
#include <matrix.h>

#define  L  50000
#define L2 500000

void updtel(vector e, int *ie, int *ne, vector we, int *ip, int K);
void updteu(vector e, int *ie, int *ne, vector we, int SIZE);


/* ֐`*/
/* ŠW}gbNXS̎RxNg𐶐֐ */
void make_matrix(int T, matrix o,
                 vector u, double nu, double rho,
                 int **num, int *cum, vector fx, vector fy, double h)
{
    int i, j, k, I, J;
    double nurho;

    matrix A = new_matrix(9, 9);
    matrix B = new_matrix(9, 4);
    matrix C = new_matrix(9, 4);
    matrix D = new_matrix(9, 9);

    nurho = nu * rho;

    for (i = 0; i < 9; i++) {
        for (j = 0; j < 4; j++)
            B[i][j] = C[i][j] = 0;
        for (j = 0; j < 9; j++)
            A[i][j] = D[i][j] = 0;
    }
    /* sA̐̓ */
    for (i = 0; i <= 3; i++)
        A[i][i] = 56;
    for (i = 4; i <= 7; i++)
        A[i][i] = 176;

    for (i = 0; i <= 3; i++)
        A[i][8] = -32;
    A[4][5] = A[4][7] = A[5][6] = A[6][7] = -32;

    for (i = 4; i <= 7; i++)
        A[i][8] = -96;

    A[0][5] = A[0][6] = A[1][6] = A[1][7] = A[2][4] = A[2][7] = A[3][4] =
        A[3][5] = 10;
    A[0][4] = A[0][7] = A[1][4] = A[1][5] = A[2][5] = A[2][6] = A[3][6] =
        A[3][7] = -18;
    A[0][1] = A[0][3] = A[1][2] = A[2][3] = -3;
    A[0][2] = A[1][3] = -2;
    A[4][6] = A[5][7] = 0;
    A[8][8] = 512;

    for (j = 0; j < 9; j++)
        for (i = 0; i < 9; i++)
            A[i][j] = A[j][i];

    for (i = 0; i < 9; i++)
        for (j = 0; j < 9; j++)
            A[i][j] = (1.0 / 90) * A[i][j];

#ifdef VERBOSE
    printf("90*A=\n");
    for (i = 0; i < 9; i++) {
        for (j = 0; j < 9; j++)
            printf("%3.0f ", 90 * A[i][j]);
        printf("\n");
    }
#endif

    /* sB̐̓ */
    for (i = 0; i < 9; i++)
        for (j = 0; j < 4; j++)
            B[i][j] = 0;

    B[0][0] = B[3][3] = -25;
    B[1][1] = B[2][2] = 25;
    B[1][0] = B[2][3] = 5;
    B[0][1] = B[3][2] = -5;
    B[4][0] = B[6][3] = 20;
    B[4][1] = B[6][2] = -20;
    B[5][0] = B[5][3] = 10;
    B[5][1] = B[5][2] = 50;
    B[7][0] = B[7][3] = -50;
    B[7][1] = B[7][2] = -10;
    B[8][0] = B[8][3] = 40;
    B[8][1] = B[8][2] = -40;


    for (i = 0; i < 9; i++)
        for (j = 0; j < 4; j++)
            B[i][j] = (h / 180.0) * B[i][j];

#ifdef VERBOSE
    printf("\n180/h*B=\n");
    for (i = 0; i < 9; i++) {
        for (j = 0; j < 4; j++)
            printf("%3.0f ", (180 / h) * B[i][j]);
        printf("\n");
    }
#endif

    /* sC̐̓ */
    for (i = 0; i < 9; i++)
        for (j = 0; j < 4; j++)
            C[i][j] = 0;

#ifdef BUG
    C[0][0] = C[1][1] = C[2][1] = C[3][0] = -5;
    C[0][3] = C[1][2] = C[2][2] = C[3][3] = 5;
    C[4][0] = C[4][1] = C[6][0] = C[6][1] = -10;
    C[4][2] = C[4][3] = C[6][2] = C[6][3] = 10;
    C[5][1] = C[7][0] = -20;
    C[5][2] = C[7][3] = 20;
    C[8][0] = C[8][1] = -40;
    C[8][2] = C[8][3] = 40;
#else
    C[0][0] = C[1][1] = -25;
    C[2][2] = C[3][3] = 25;
    C[0][3] = C[1][2] = -5;
    C[3][0] = C[2][1] = 5;
    C[4][0] = C[4][1] = -50;
    C[4][2] = C[4][3] = -10;
    C[5][1] = C[7][0] = 20;
    C[5][2] = C[7][3] = -20;
    C[6][0] = C[6][1] = 10;
    C[6][2] = C[6][3] = 50;
    C[8][0] = C[8][1] = 40;
    C[8][2] = C[8][3] = -40;
#endif

    for (i = 0; i < 9; i++)
        for (j = 0; j < 4; j++)
            C[i][j] = (h / 180.0) * C[i][j];

#ifdef VERBOSE
    printf("\n180/h*C=\n");
    for (i = 0; i < 9; i++) {
        for (j = 0; j < 4; j++)
            printf("%3.0f ", (180 / h) * C[i][j]);
        printf("\n");
    }
#endif

    /* sD̐̓ */
    for (i = 0; i <= 3; i++)
        D[i][i] = 16;
    for (i = 4; i <= 7; i++)
        D[i][i] = 64;

    for (i = 0; i <= 3; i++)
        D[i][8] = 4;
    D[4][5] = D[4][7] = D[5][6] = D[6][7] = 4;

    for (i = 4; i <= 7; i++)
        D[i][8] = 32;

    D[0][5] = D[0][6] = D[1][6] = D[1][7] = D[2][4] = D[2][7] = D[3][4] =
        D[3][5] = -2;
    D[0][4] = D[0][7] = D[1][4] = D[1][5] = D[2][5] = D[2][6] = D[3][6] =
        D[3][7] = 8;
    D[0][1] = D[0][3] = D[1][2] = D[2][3] = -4;
    D[0][2] = D[1][3] = 1;
    D[4][6] = D[5][7] = -16;
    D[8][8] = 256;

    for (j = 0; j < 9; j++)
        for (i = 0; i < 9; i++)
            D[i][j] = D[j][i];

    for (i = 0; i < 9; i++)
        for (j = 0; j < 9; j++)
            D[i][j] = (h * h / 900.0) * D[i][j];

#ifdef VERBOSE
    printf("\nD=\n");
    for (i = 0; i < 9; i++) {
        for (j = 0; j < 9; j++)
            printf("%4.0f ", 900 / (h * h) * D[i][j]);
        printf("\n");
    }
#endif

    /* ڍ@ */
    for (k = 0; k < T; k++) {
        for (i = 0; i < 9; i++) {
            I = cum[num[k][i]];
            for (j = 0; j < 9; j++) {
                J = cum[num[k][j]];
                o[I][J] += nurho * A[i][j];
                o[I + 1][J + 1] += nurho * A[i][j];
            }

            for (j = 0; j < 4; j++) {
                J = cum[num[k][j]];
                o[I][J + 2] -= B[i][j];
                o[I + 1][J + 2] -= C[i][j];
#ifdef ADD
                o[J + 2][I] -= B[i][j];
                o[J + 2][I + 1] -= C[i][j];
#endif
            }

            for (j = 0; j < 9; j++) {
                u[I] += rho * D[i][j] * fx[num[k][j]];
                u[I + 1] += rho * D[i][j] * fy[num[k][j]];
            }
        }
#ifndef ADD
        for (i = 0; i < 4; i++) {
            I = cum[num[k][i]];
            for (j = 0; j < 9; j++) {
                J = cum[num[k][j]];
                o[I + 2][J] -= B[j][i];
                o[I + 2][J + 1] -= C[j][i];
            }
        }
#endif
    }
    free_matrix(A);
    free_matrix(B);
    free_matrix(C);
    free_matrix(D);
}

void change(matrix o, int k, int SIZE)
{
    int i;

    for (i = 0; i < SIZE; i++) {
        o[k][i] = 0.0;
    }
    o[k][k] = 1.0;
}

void bound(matrix o, vector u, int *b, vector bx, vector by,
           int D, int *cum, int SIZE)
{
    int i, j;

    for (i = 0; i < D; i++) {
        j = cum[b[i]];
        change(o, j, SIZE);
        change(o, j + 1, SIZE);
        u[j] = bx[i];
        u[j + 1] = by[i];
    }
    /* if(N==0){ */
    change(o, 2, SIZE);
    u[2] = 0.0;
}

void etalu(matrix o, vector u, int SIZE)
{
    int i, j, k, jk, irow;
    int *ia, *ie, *nwk, num, *ne, *ip, is, ier;
    double val, work, piv, eps = 1.0e-14;
    double *a, *e;
    vector x, we, b;

    if ((nwk = malloc(sizeof(int) * (SIZE + 1))) == NULL) {
        printf("etalu:nwkp̃[܂\n");
    }
    if ((ne = malloc(sizeof(int) * (2 * (SIZE + 1)))) == NULL) {
        printf("etalu:nep̃[܂\n");
    }
    if ((ip = malloc(sizeof(int) * (SIZE + 1))) == NULL) {
        printf("etalu:ipp̃[܂\n");
    }
    if ((ia = malloc(sizeof(int) * L)) == NULL) {
        fprintf(stderr, "etalu: xNg ia p̃[܂\n");
    }
    if ((ie = malloc(sizeof(int) * L2)) == NULL) {
        fprintf(stderr, "etalu: xNg ie p̃[܂\n");
    }
    if ((a = malloc(sizeof(double) * L)) == NULL) {
        fprintf(stderr, "etalu: xNg a p̃[܂\n");
    }
    if ((e = malloc(sizeof(double) * L2)) == NULL) {
        fprintf(stderr, "etalu: xNg e p̃[܂\n");
    }
    x = new_vector(SIZE + 1);
    we = new_vector(SIZE + 1);
    b = new_vector(SIZE + 1);

    k = 1;
    nwk[0] = 0;
    for (i = 0; i < SIZE; i++) {
        for (j = 0; j < SIZE; j++) {
            if (o[j][i] != 0.0) {
                a[k] = o[j][i];
                ia[k] = j + 1;
                k++;
            }
        }
        nwk[i + 1] = k - 1;
    }

    for (i = 0; i < SIZE; i++)
        b[i + 1] = u[i];

    if (L <= SIZE) {
        printf("INVALID ARGUMENT. %d %d \n", L, SIZE);
        ier = 2;
        return;
    }

    ier = is = ne[0] = ne[1] = num = 0;

    for (i = 1; i <= SIZE; i++)
        ip[i] = 0;
    for (k = 1; k <= SIZE; k++) {
        for (i = 1; i <= SIZE; i++)
            we[i] = 0.0;
        for (i = nwk[k - 1] + 1; i <= nwk[k]; i++)
            we[ia[i]] = a[i];
        if (k != 1) {
            jk = k - 1;
            updtel(e, ie, ne, we, ip, jk);
            /* COMPUTATION OF ETA */
        }
        /* SELECTION OF PIVOT */
        irow = 0;
        val = 0.0;
        for (i = k; i <= SIZE; i++) {
            work = fabs(we[i]);
            if (work > val) {
                val = work;
                irow = i;
            }
        }
        if (val <= eps) {
            printf("STOP WITH ZERO PIVOT %d \n", k);
            ier = 1;
            return;
        }
        ip[k] = irow;
        if (irow != k) {
            work = we[k];
            we[k] = we[irow];
            we[irow] = work;
        }
/* WRITE(*,*) (WE[i],I=1,M) */
/* GENERATION OF ETA */
        piv = -1.0 / we[k];
        we[k] = -1.0;
        for (i = k; i <= SIZE; i++) {
            we[i] *= piv;
            if (fabs(we[i]) >= eps) {
                num++;
                e[num] = we[i];
                ie[num] = i;
            }
        }
        ne[2 * k] = num;
        if (k == 1) {
            ne[3] = ne[2];
        } else {
            for (i = 1; i < k; i++) {
                if (fabs(we[i]) >= eps) {
                    num++;
                    e[num] = -we[i];
                    ie[num] = i;
                }
            }
            ne[2 * k + 1] = num;
        }
    }
/* COMPUTION OF X */
    for (k = 1; k <= SIZE; k++)
        x[k] = b[k];
    updtel(e, ie, ne, x, ip, SIZE);
    updteu(e, ie, ne, x, SIZE);

    for (k = 0; k < SIZE; k++)
        u[k] = x[k + 1];

    free(ia);
    free(ie);
    free(nwk);
    free(ne);
    free(ip);
    free(a);
    free(e);
    free_vector(x);
    free_vector(we);
    free_vector(b);
}

void updtel(vector e, int *ie, int *ne, vector we, int *ip, int K)
{
    int i, j, irow;
    double work;

    for (j = 1; j <= K; j++) {
        irow = ip[j];
        if (irow != j) {
            work = we[j];
            we[j] = we[irow];
            we[irow] = work;
        }
        work = we[j];
        we[j] = 0.0;
        for (i = ne[2 * j - 1] + 1; i <= ne[2 * j]; i++) {
            we[ie[i]] += e[i] * work;
        }
    }
}

void updteu(vector e, int *ie, int *ne, vector we, int SIZE)
{
    int i, j;
    double work;

    for (j = SIZE; j >= 2; j--)
        if (ne[2 * j] != ne[2 * j + 1]) {
            work = we[j];
            for (i = ne[2 * j] + 1; i <= ne[2 * j + 1]; i++)
                we[ie[i]] += e[i] * work;
        }
}

int main(int argc, char **argv)
{
  /**************** ϐ錾***************/
    int i, j;
    /* ̓t@CAo̓t@C */
    FILE *f1, *f2;
    /* T:vf, U:ړ_, SIZE:m̑ */
    int U, T, SIZE;
    /* D:DirichletE̐ߓ_̑ */
    int D;
    int *cum, **num, *b;
    /* nu:S萔, rho:x, h:bV */
    double nu, rho, h;
    /* bx,by:El, fx,fy:O͖x */
    vector x, y, bx, by, fx, fy;
    /* S̎RxNg */
    vector u;
    /* ŠW}gbNX */
    matrix o;
#ifdef VERBOSE
    int count_zero;
#endif

    if (argc != 3) {
        fprintf(stderr, "usage: %s <input> <output>\n", argv[0]);
        exit(1);
    }
    if ((f1 = fopen(argv[1], "r")) == NULL) {
        fprintf(stderr, "Can't open %s", argv[1]);
        exit(1);
    }

    fscanf(f1, "%d %d %lf", &T, &U, &h);
    printf("vf,ߓ_,h=\n%d %d %f\n", T, U, h);

    x = new_vector(U);
    y = new_vector(U);
    for (i = 0; i < U; i++)
        fscanf(f1, "%lf %lf", &x[i], &y[i]); /* i:S̐ߓ_ԍ, x,y:ߓ_̍W */
#ifdef VERBOSE
    printf("ߓ_̍W x[],y[]\n");
    for (i = 0; i < U; i++)
        printf("%f %f\n", x[i], y[i]);
#endif

    num = (int **) malloc(T * sizeof(void *));
    if (num == NULL) {
        printf("vfƐߓ_̑Ήp̃[܂\n");
	exit(4);
    }
    for (i = 0; i < T; i++) {
        num[i] = (int *) malloc(sizeof(int) * 9);
        if (num[i] == NULL) {
            printf("vfƐߓ_̑Ήp̃[܂\n");
	    exit(4);
        }
    }
    for (i = 0; i < T; i++)
        for (j = 0; j < 9; j++)
            fscanf(f1, "%d", &num[i][j]);

#ifdef VERBOSE
    printf("vfߓ_Ή\\n");
    for (i = 0; i < T; i++) {
        printf("%3dvf: ", i);
        for (j = 0; j < 9; j++)
            printf("%d ", num[i][j]);
        printf("\n");
    }
#endif

    if ((cum = (int *) malloc(sizeof(int) * U)) == NULL) {
        printf("ݐϐߓ_ԍp̃[܂ \n");
	exit(4);
    }
    for (i = 0; i < U; i++)
        fscanf(f1, "%d", &cum[i]);      /* i:S̐ߓ_ԍ, cum:ݐϐߓ_ԍ */

#ifdef VERBOSE
    printf("ݐϐߓ_ԍ\n");
    for (i = 0; i < U; i++) {
        printf("%d ", cum[i]);
        if ((i + 1) % 10 == 0)
            printf("\n");
    }
    printf("\n");
#endif

    fscanf(f1, "%d", &SIZE);
    printf("ߓ_=%d\n", SIZE);

    u = new_vector(SIZE);
    o = new_matrix(SIZE, SIZE);
    for (i = 0; i < SIZE; i++) {
        u[i] = 0.0;
        for (j = 0; j < SIZE; j++)
            o[i][j] = 0.0;
    }

    fscanf(f1, "%lf %lf", &nu, &rho);
    fscanf(f1, "%d", &D);

    printf(",=\n%f %f\n", nu, rho);
    printf("E̐ߓ_=%d\n", D);
    if ((b = (int *) malloc(sizeof(int) * D)) == NULL) {
        printf("E̔ԍp̃[܂B\n");
	exit(4);
    }
    bx = new_vector(D);
    by = new_vector(D);
    for (i = 0; i < D; i++) {
        fscanf(f1, "%d %lf %lf", &b[i], &bx[i], &by[i]);  /* El (u,v) */
#ifdef VERBOSE
        printf("%d %f %f\n", b[i], bx[i], by[i]);
#endif
    }
    printf("\n");

    fx = new_vector(U);
    fy = new_vector(U);
    for (i = 0; i < U; i++)
        fscanf(f1, "%lf %lf", &fx[i], &fy[i]);  /* O͂x,y */
#ifdef VERBOSE
    printf("O\n");
    for (i = 0; i < U; i++)
        printf("%f %f\n", fx[i], fy[i]);
#endif
    fclose(f1);

    /* ͂̊mF 
       printf("vf: %d ړ_: %d XP[p[^:%f\n", T,U,h);
       for(i=0;i<U;i++)
       printf("xW:%f yW:%f\n", x[i],y[i]);
       puts("\nǏߓ_ԍƑS̐ߓ_ԍƂ̑Ή");
       for(i=0;i<T;i++){
       for(j=0;j<9;j++)
       printf("%d", num[i][j]);
       printf("\n");
       }
       for(i=0;i<U;i++)
       printf("ݐϐߓ_:%d\n", cum[i]);
       printf("SIZE: %d\n", SIZE);
       printf("SW:%f x:%f\n", nu, rho);
       printf("E(Dirichlet)̐ߓ_:%d\n", D);
     */

    /* ŠW}gbNXAS̎RxNg̐ */
    make_matrix(T, o, u, nu, rho, num, cum, fx, fy, h);

#ifdef VERBOSE
    printf("bound() O\n");
    for (i = 0; i < SIZE; i++) {
        for (j = 0; j < SIZE; j++)
            if (o[i][j] != 0)
                putchar('*');
            else
                putchar('0');
        printf("\n");
    }
#endif

    bound(o, u, b, bx, by, D, cum, SIZE);

#ifdef VERBOSE
    printf("bound() \n");
    count_zero = 0;
    for (i = 0; i < SIZE; i++) {
        int is_zero = 1;
        for (j = 0; j < SIZE; j++)
            if (o[i][j] != 0) {
                putchar('*');
                is_zero = 0;
            } else
                putchar('0');
        printf("\n");
        if (is_zero) {
            printf("%ds 0 ł\n", i);
            count_zero++;
        }
    }
    printf("0xNgłš=%d\n", count_zero);
#endif

    free(num);
#ifdef NEVER
    free_vector(x);
    free_vector(y);
#endif
    free_vector(fx);
    free_vector(fy);

    free(b);
    free(cum);
    free_vector(bx);
    free_vector(by);

    /* Aꎟ */
    etalu(o, u, SIZE);

    if ((f2 = fopen(argv[2], "w")) == NULL) {
        printf("Can't open %s", argv[2]);
        exit(2);
    }

    for (i = 0; i < SIZE; i++) {
        fprintf(f2, "%f \n", u[i]);
    }

    fclose(f2);

    return 0;
}
